<?php
/**
 * Main Plugin File
 * Does all the magic!
 *
 * @package     Better Preview
 * @version     1.8.3
 *
 * @author      Peter van Westen <peter@nonumber.nl>
 * @link        http://www.nonumber.nl
 * @copyright   Copyright © 2011 NoNumber! All Rights Reserved
 * @license     http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

// Import library dependencies
jimport( 'joomla.event.plugin' );

/**
* Plugin that makes the preview button as it should be
*/
class plgSystemBetterPreview extends JPlugin
{
	var $_name = 'betterpreview';

	/**
	* Constructor
	*
	* For php4 compatibility we must not use the __constructor as a constructor for
	* plugins because func_get_args ( void ) returns a copy of all passed arguments
	* NOT references. This causes problems with cross-referencing necessary for the
	* observer design pattern.
	*/
	function plgSystemBetterPreview( &$subject, $config )
	{
		parent::__construct( $subject, $config );
	}

	function onAfterRoute()
	{
		$this->_pass = 0;
		$mainframe =& JFactory::getApplication();

		// if current page is not an administrator page, return nothing
		if ( $mainframe->isSite() && JRequest::getCmd( 'action' ) != 'betterpreview' ) { return; }

		$document =& JFactory::getDocument();
		$docType = $document->getType();

		// only in html
		if ( $docType != 'html' ) { return; }

		// load the admin language file
		$lang =& JFactory::getLanguage();
		$lang->load( 'plg_'.$this->_type.'_'.$this->_name, JPATH_ADMINISTRATOR, 'en-GB' ); // Loads English language file as fallback (for undefined stuff in other language file)
		$lang->load( 'plg_'.$this->_type.'_'.$this->_name, JPATH_ADMINISTRATOR, null, 1 );

		// return if NoNumber! Elements plugin is not installed
		jimport( 'joomla.filesystem.file' );
		if ( !JFile::exists( JPATH_PLUGINS.DS.'system'.DS.'nonumberelements.php' ) ) {
			if ( $mainframe->isAdmin() && JRequest::getCmd( 'option' ) !== 'com_login' ) {
				$mainframe->enqueueMessage( '', 'error' );
				$msg = JText::_( 'BP_NONUMBER_ELEMENTS_PLUGIN_NOT_INSTALLED' );
				foreach ( $mainframe->_messageQueue as $m ) {
					if ( $m['message'] == $msg ) {
						$msg = '';
						break;
					}
				}
				$mainframe->enqueueMessage( $msg, 'error' );
			}
			return;
		}

		$this->_pass = 1;

		// Load plugin parameters
		require_once JPATH_PLUGINS.DS.'system'.DS.'nonumberelements'.DS.'helpers'.DS.'parameters.php';
		$parameters =& NNParameters::getParameters();
		$db =& JFactory::getDBO();
		$query = "SELECT params"
			." FROM #__modules"
			." WHERE module = 'mod_betterpreview'"
			." LIMIT 1"
			;
		$db->setQuery( $query );
		$params = $db->loadResult();
		$params = $parameters->getParams( $params, JPATH_ADMINISTRATOR.DS.'modules'.DS.'mod_betterpreview'.DS.'mod_betterpreview.xml' );

		// Include the Helper
		require_once JPATH_PLUGINS.DS.$this->_type.DS.$this->_name.DS.'helper.php';
		$class = get_class( $this ).'Helper';
		$this->helper = new $class( $params );

		$this->helper->prePreviewArticle();
	}

	function onPrepareContent( &$article )
	{
		if ( $this->_pass ) {
			$this->helper->previewArticle( $article );
		}
	}

	function onAfterRender()
	{
		if ( $this->_pass ) {
			$this->helper->updateBody();
		}
	}
}