<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class  plgSystemJBMailTmpl extends JPlugin
{

    function parseTemplate($tmpl, $mailVars) {
        foreach ($tmpl as $key => $tmplField) {
            foreach ($mailVars as $varName => $mailVar) {
                $tmpl[$key] = $tmplField = str_replace('#'.mb_strToUpper(trim($varName)).'#', $mailVar, $tmplField);
            }
        }
        return $tmpl;
    }

    
    function addVars($vars = array(), $isHtml = 1) {
        $config = JFactory::getConfig();

        $vars['ALL_FIELDS'] = '';
        foreach($vars as $varName=>$value) {
            if ($varName == 'ALL_FIELDS') continue;
            $vars['ALL_FIELDS'] .= '<b>'.mb_strToLower($varName).':</b> '.$value.'<br>'."\n";
        }

        if (!isset($vars['IP'])) { $vars['IP'] = JRequest::getVar('REMOTE_ADDR', '', 'SERVER'); }
        
        if (!isset($vars['DATE'])) {
            $date   = JFactory::getDate('now');
            $date->setOffset($config->getValue('config.offset'));
            $vars['DATE'] = $date->toFormat("%Y-%m-%d").' '. $date->toFormat("%H:%M:%S");
        }

       if (!isset($vars['PAGE'])) {
            $url = JURI::root().ltrim(JRequest::getVar('REQUEST_URI', JURI::current(), 'SERVER'), '/');
            if ($isHtml) {  $vars['PAGE'] = '<a href="'.$url.'" target="_blank">'.$url.'</a>';
            } else {        $vars['PAGE'] = $url; }
        }
        
        if (!isset($vars['REFERER'])) { $vars['REFERER'] = JRequest::getVar('HTTP_REFERER', '', 'SERVER'); }
                
        if (!isset($vars['SITENAME'])) {
            if ($isHtml) {  $vars['SITENAME'] = '<a href="'.JURI::root().'">'.$config->getValue('sitename').'</a>';
            } else {        $vars['SITENAME'] = $config->getValue('sitename'); }
        }
        
        if (!isset($vars['SITEURL'])) {
            if ($isHtml) {  $vars['SITEURL'] = '<a href="'.JURI::root().'">'.JURI::root().'</a>';
            } else {        $vars['SITEURL'] = JURI::root(); }
        }
        
        if (!isset($vars['USER_AGENT'])     ) { $vars['USER_AGENT']      = JRequest::getVar('HTTP_USER_AGENT', '', 'SERVER');}
        if (!isset($vars['ACCEPT_LANGUAGE'])) { $vars['ACCEPT_LANGUAGE'] = JRequest::getVar('HTTP_ACCEPT_LANGUAGE', '', 'SERVER');}

        if (!isset($vars['COOKIE'])         ) {
            $cookie = JRequest::getVar('HTTP_COOKIE', '', 'SERVER');
            $cookieArr = explode(';', trim($cookie, ';'));
            $arrCookie = array();
            $vars['COOKIE'] = 'COOKIE<br/>';
            foreach($cookieArr as $oneCookie) {
                $values = explode('=', $oneCookie);
                $vars['COOKIE'] .= '&nbsp;&nbsp;&nbsp;&nbsp;<b>'.mb_strToLower($values[0]).' :</b> '.$values[1].'<br>'."\n";
            }

        }

        if (!isset($vars['ACCEPT_CHARSET']) ) { $vars['ACCEPT_CHARSET']  = JRequest::getVar('HTTP_ACCEPT_CHARSET', '', 'SERVER');}

        if (!isset($vars['SYSTEM_INFO'])) {
            $vars['SYSTEM_INFO'] = '<br>--------------------------------------------------<br>'."\n";
            foreach ($vars as $varName=>$value) {
                if (in_array($varName, array('IP', 'DATE', 'PAGE', 'REFERER', 'SITENAME', 'SITEURL', 'USER_AGENT', 'ACCEPT_LANGUAGE', 'COOKIE', 'ACCEPT_CHARSET'))) {
                    $vars['SYSTEM_INFO'] .= '<b>'.mb_strToLower($varName).' :</b> '.$value.'<br>'."\n";
                }
            }
        }

        return $vars;
    }

    function plgSystemJBMailTmpl(& $subject, $config) {
        parent::__construct($subject, $config);
        
        $disable = $this->params->get('disable', 0);     
        
        if ($disable) {
            function JBMailTmpl($event = '', $fields = array()) {
                return false;
            }
            
        } else {
            function JBMailTmpl($event, $mailVars = array()) {

                $logFields = "{DATE}\t{TIME}\t{LEVEL}\t{C-IP}\t";
                foreach($mailVars as $key=>$val) {
                    $logFields .= '{'.JString::strToUpper($key)."}\t\t";
                }
                

                jimport('joomla.error.log');
                $logName = 'auto_'.JString::strToLower($event).'.php';
                $log = JLog::getInstance($logName, array('format'=> $logFields));
                $log->addEntry($mailVars);
                
                
                $config = & JFactory::getConfig();
                $mail = & JFactory::getMailer();               
                $plugin = & JPluginHelper::getPlugin('system', 'jbmailtmpl');
                $pluginParams = new JParameter($plugin->params);
                
                $host = JRequest::getVar('HTTP_HOST', '', 'SERVER');
                $default_email   = $pluginParams->get('default_email', 'admin@'.$host);
                $default_subject = $pluginParams->get('default_subject', 'Mail from site:'.$host);
                
                $results = plgSystemJBMailTmpl::getTemplates($event);
                if (count($results) > 0 ) {
                    foreach($results as $tmpl) {
                        $mailVars = plgSystemJBMailTmpl::addVars($mailVars, ($tmpl['mail_type'] != 0));

                        $tmpl['mail_to']        = (strlen($tmpl['mail_to']) > 0) ? $tmpl['mail_to'] : $default_email;
                        $tmpl['mail_subject']   = (strlen($tmpl['mail_subject']) > 0) ? $tmpl['mail_subject'] : $mail_subject;
                        $tmpl['mail_text']      = (strlen($tmpl['mail_text']) > 0) ? $tmpl['mail_text'] : '#ALL_FIELDS# #SYSTEM_INFO#';
                        if (strlen($tmpl['mail_from']) > 0) {
                            $tmpl['mail_from'] = explode('|', $tmpl['mail_from']);
                        }

                        $tmpl = plgSystemJBMailTmpl::parseTemplate($tmpl, $mailVars);

                        
                        $mail->isHTML(($tmpl['mail_type'] != 0));
                        if (count($tmpl['mail_from']) == 2) {
                            $mail->setSender( array( $tmpl['mail_from'][0], $tmpl['mail_from'][1]));
                        } else {
                            $mailfrom   = $config->getValue('config.mailfrom');
                            $fromname   = $config->getValue('config.fromname');
                            $mail->setSender(array ($mailfrom, $fromname));
                        }
                        $mail->addRecipient($tmpl['mail_to']);
                        $mail->setSubject($tmpl['mail_subject']);
                        $mail->setBody($tmpl['mail_text']);
                        $sent = $mail->Send();
                    }
                } else {
                    $mailVars = plgSystemJBMailTmpl::addVars($mailVars, true);
                    $body = $mailVars['ALL_FIELDS'] .' '. $mailVars['SYSTEM_INFO'];
                    $mail->isHTML(true);
                    $mail->addRecipient($default_email);
                    $mail->setSubject($event .' | '. $default_subject);
                    $mail->setBody($body);
                    $sent = $mail->Send();
                }
            }
            
        }
    }
    
    function getTemplates($event) {
        $db =& JFactory::getDBO();
        $db->setQuery('SELECT * FROM #__jb_mailtmpl WHERE status > 0 AND event = "'.trim(mb_strToLower($event)).'"');
        $result = $db->loadAssocList();
        return $result;
    }
    
}
