<?php
/*
 * J!Blank Template for Joomla 1.5.x
 * @author joomla-book.ru
 * @email admin@joomla-book.ru
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

require_once(dirname(__FILE__).DS.'helper.php');

// Take the necessary facilities
$config     = & JFactory::getConfig();
$document   = & JFactory::getDocument();
$user       = & JFactory::getUser();
$url        = & JFactory::getURI();

$date       = & JFactory::getDate('now');
$date->setOffset($config->getValue('config.offset'));

$menu       = & JSite::getMenu();
$curItemid  = $menu->getActive();
if (!isset($curItemid->id)) {
    $curItemid = new stdClass;
    $curItemid->id = -1;
}
$defItemid  = $menu->getDefault();

$path = JURI::root().'templates/'.$document->template.'/';
$def_lang = explode('-',  $this->getLanguage());
$tpl = array(
    'option'        => JRequest::getVar('option', ''),
    'view'          => JRequest::getVar('view', ''),
    'layout'        => JRequest::getVar('layout', ''),
    'lang'          => JRequest::getVar('lang', $def_lang[0]),
    'langDef'       => $def_lang[0],
    'curItemid'     => $curItemid->id,
    'defItemid'     => $defItemid->id,
    'date'          => $date->toFormat($this->params->get('date-format')),
    'title'         => $document->getTitle(),
    'sitename'      => $config->getValue('sitename'),
    'path'          => $path,
    'img'           => $path.'images',
    'css'           => $path.'css',
    'js'            => $path.'js',
    'userGuest'     => ($user->get('guest') == 1) ? true : false,
    'userId'        => ($user->id != 0) ? $user->id : 0,
    'front'         => ($curItemid->id == $defItemid->id) ? true : false,
    'baseurl'       => $document->baseurl,
    'dir'           => $document->getDirection(),
    'live_site'     => $config->getValue('config.live_site') ? $config->getValue('config.live_site') : $document->baseurl,
    'tmpl'          => JRequest::getVar('tmpl', 'index'),
);

// css framework
if ($this->params->get('css-framework')) {
    if ($this->params->get('css-framework-reset'))      JBlankHelper::includeCSS('reset');
    if ($this->params->get('css-framework-layout'))     JBlankHelper::includeCSS('layout');
    if ($this->params->get('css-framework-typography')) JBlankHelper::includeCSS('typography');
    if ($this->params->get('css-framework-print'))      JBlankHelper::includeCSS('print', '', 'print');    
}

if ($this->params->get('css-ie-autodetect'))            JBlankHelper::includeIEHacks();

// Own style template
if ($this->params->get('css-styles')) JBlankHelper::includeCSS('styles');

// tmpl-CSS autodetect
if ($this->params->get('css-tmpl-autodetect')) {
    JBlankHelper::includeCSS($tpl['option']);
    JBlankHelper::includeCSS($tpl['tmpl'], 'tmpl_');
    if ($this->getBuffer('message')) {
        JBlankHelper::includeCSS('system');
    }
}

// jQuery Framework
if ($this->params->get('jquery')) {
    if ($this->params->get('jquery-core'))      JBlankHelper::includeJS('jquery.core.pack');
    if ($this->params->get('jquery-swfobject')) JBlankHelper::includeJS('jquery.swfobject.pack');
    if ($this->params->get('jquery-png'))       JBlankHelper::includeJS('jquery.pngfix.pack');
    if ($this->params->get('jquery-tools'))     JBlankHelper::includeJS('jquery.tools');
}

$codePath = dirname(__FILE__).DS.'_code.php';
if(JFile::exists($codePath) && filesize($codePath) > 10) require_once($codePath);

//javascript file
if ($this->params->get('js-script'))            JBlankHelper::includeJS('scripts');

// meta for cross-browsing
if ($this->params->get('smarttags'))    $document->addCustomTag( '<meta name="MSSmartTagsPreventParsing" content="true" />' );
if ($this->params->get('compatible'))   $document->addCustomTag( '<meta http-equiv="X-UA-COMPATIBLE" content="IE=EmulateIE8" />' );
if ($this->params->get('imagetoolbar')) $document->addCustomTag( '<meta http-equiv="imagetoolbar" content="false" />' );
if ($this->params->get('language'))     $document->addCustomTag( '<meta http-equiv="content-Language" content="'.$tpl['lang'].'" />' );

if ($this->params->get('generator'))    $document->setGenerator($this->params->get('generator'));

if (!$this->params->get('mootools')) {
    $headerstuff = $this->getHeadData();
    $tmp = array();

    foreach ($headerstuff['scripts'] as $path=>$type) {
        if (!preg_match('#(mootools||caption)#i', $path, $ar)) $tmp[$path] = $type;
    }
    $headerstuff['scripts'] = $tmp;
    $this->setHeadData($headerstuff);

}

